﻿// dllmain.cpp : DLL アプリケーションのエントリ ポイントを定義します。
#include "pch.h"

#pragma warning(disable : 4996)

#include <stdio.h>
#include <windows.h>
#include <tchar.h>
#include "framework.h"

#include <stdlib.h>
#include <time.h>

#include <shobjidl_core.h>

#include "mmeapi.h"

HWND HWNDfullscr;

bool isbeepplayed = false;
bool bool4showwin = true;

#define SRATE    44100    //標本化周波数(1秒間のサンプル数)
#define F        2400     //周波数(1秒間の波形数)

WAVEFORMATEX wfe;
static HWAVEOUT hWaveOut;
static WAVEHDR whdr;
static LPBYTE lpWave;
int i, len;


void beepinit() {

    wfe.wFormatTag = WAVE_FORMAT_PCM;
    wfe.nChannels = 1;    //モノラル
    wfe.wBitsPerSample = 8;    //量子化ビット数
    wfe.nBlockAlign = wfe.nChannels * wfe.wBitsPerSample / 8;
    wfe.nSamplesPerSec = SRATE;    //標本化周波数
    wfe.nAvgBytesPerSec = wfe.nSamplesPerSec * wfe.nBlockAlign;

    waveOutOpen(&hWaveOut, WAVE_MAPPER, &wfe, 0, 0, CALLBACK_NULL);

    lpWave = (LPBYTE)calloc(wfe.nAvgBytesPerSec, 2);    //2秒分

    len = SRATE / F;    //波長
    for (i = 0; i < SRATE * 2; i++) {  //波形データ作成
        if (i % len < len / 2)    lpWave[i] = 128 + 64;
        else                 lpWave[i] = 128 - 64;
    }

    whdr.lpData = (LPSTR)lpWave;
    whdr.dwBufferLength = wfe.nAvgBytesPerSec * 2;
    whdr.dwFlags = WHDR_BEGINLOOP | WHDR_ENDLOOP;
    whdr.dwLoops = -1;

    waveOutPrepareHeader(hWaveOut, &whdr, sizeof(WAVEHDR));
}

void beep2400play() {
    if (isbeepplayed == false) {
        waveOutWrite(hWaveOut, &whdr, sizeof(WAVEHDR));
        isbeepplayed = true;
    }
}

void beep2400stop(){
    if (isbeepplayed == true) {
        waveOutReset(hWaveOut);
        isbeepplayed = false;
    }
}

FILE* cmtfile;
char FileName[MAX_PATH * 2];

int cmtseek = 0;

wchar_t FilterW[4096];
wchar_t FileNameW[4096];

typedef unsigned char uint8;
typedef unsigned short uint16;
typedef unsigned long uint32;
typedef signed char int8;
typedef signed short int16;
typedef signed long int32;

#pragma warning(disable : 4996)

#ifdef _ARM_
#pragma comment(lib,"bz80dll_arm.lib")
#else
#ifdef _M_ARM64
#pragma comment(lib,"bz80dll_arm64.lib")
#else
#ifdef _M_AMD64
#pragma comment(lib,"bz80dll_x64.lib")
#else
#pragma comment(lib,"bz80dll.lib")
#endif
#endif
#endif
extern "C" __declspec(dllimport) void setz80memaccess(int (*tmp)(int, int, int));
extern "C" __declspec(dllimport) void Z80Init(void);
extern "C" __declspec(dllimport) void Z80Reset(void);
extern "C" __declspec(dllimport) int  Z80Run(void);
extern "C" __declspec(dllimport) void Z80DoIRQ(uint8 vector);
extern "C" __declspec(dllimport) void Z80DoNMI(void);
extern "C" __declspec(dllimport) int getz80regs();
extern "C" __declspec(dllimport) int getextz80regs(int tmp);


time_t timer;
struct tm local_time;

bool biosromenabled=false;

uint8 bios[0x6000];
uint8 memory[0x10000];
uint8 fontrom[0x800];

uint8 pc8001keybool[0x10];

HANDLE Z80Threadid = 0;
HANDLE BSThreadid = 0;
HANDLE BGThreadid = 0;
HANDLE RTIThreadid = 0;
int clockcount = 0;
bool videoenabled = false;
bool beepenabled = true;
uint8 uPD8251config[4];
uint8 upd8251configate = 0;
bool overrunerror = false;
bool rxdataready = false;
uint8 crtc2 = 0;

uint8 bgcolor = 0;
bool colorgraphicmode = false;
bool graphicdraw = true;
bool grpmode = false;
bool romtype = false;

uint8 uipin = 0;
bool vbi = false;
bool rtcdata = false;
bool fddconnected = false;
bool cmtdatard = false;
bool prtready = false;

bool othercrtcio = false;
int upd31speclzsig;
int litepeninp;

uint8 upd3301stat = 0;
uint8 uPD3301prm = 0;
uint8 upd3301cmd = 0;

uint16 dmaas[4];
uint16 dmatc[4];
uint8 dmachiocnt = 0;
uint8 dmamodestat = 0;
uint8 dmaseq = 0;
uint8 crtcactive = 0;
int cursx = -1;
int cursy = -1;

bool grpheight25 = false;
uint8 blinkingtime = 0;
uint8 cursxtmp = 0;

uint8 uopout = 0;

uint8 ret = 0;

uint8 seq = 0;

uint8 crtc3 = 0;

HDC hdc = 0;
HDC hdcfullscr = 0;
HBITMAP hOldCBitmap;

int pc8001kb1p;

int chkedbb8 = 0;

bool crtcldsclkenable = false;
bool rtcclkenable = false;
bool rtcstbenable = false;
bool prtenable = false;
bool prtenable0 = false;

bool cassettemtstate = false;
uint8 cmtbinsnd = 0;
bool cmtdatawr = false;
bool crtmodectrl = false;
bool pc8001widthflag = false;

bool isharftoneenabled = false;

tm* timexforch1;
tm timezforch1;
time_t timerforch123;
uint8 rtctimeforminus[5];

uint8 pch = 0;

time_t* nptime_t;
tm* nptm;


int rtctimeforminusck[5] = { 6, 5, 4, 3, 1 };
int rtctimeforminusck3[5] = { 59, 59, 23, 31, 12 };
int rtctimeforminusck2[5];
tm* timey;

uint16 rtcpos = 0;
int rtctimetmp[5];
int rtctime[5];

HDC hCDC;
HBITMAP hCBitmap;
HDC hCDCfullscr;
HBITMAP hCBitmapfullscr;
HPEN hPen;
HBRUSH hBackGround[256];
RECT rs;

HBITMAP hbDib;

BYTE* pBit;

uint8 ioporte6h = 0;

bool drawgrpbool = false;

uint8 pc8001kmp[256] = { 255,255,255,255,255,255,255,255,131,145,255,255,255,23,255,255,134,135,132,255,255,255,255,255,255,255,255,151,255,133,255,255,150,255,255,144,128,130,129,130,129,255,255,255,255,255,22,255,96,97,98,99,100,101,102,103,112,113,255,255,255,255,255,255,255,33,34,35,36,37,38,39,48,49,50,51,52,53,54,55,64,65,66,67,68,69,70,71,80,81,82,255,255,132,255,255,0,1,2,3,4,5,6,7,16,17,18,19,20,21,22,20,145,146,147,148,149,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,114,115,116,87,117,118,32,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,83,84,85,86,255,255,255,119,255,255,133,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255 };
int timexforch1tm_year4ml = 0;

int tofs = 0;

void rtcstrobe() { switch (pch & 0xF) { case 1:timerforch123 = time(0) + tofs; timey = localtime(&timerforch123); rtctimeforminusck2[0] = timey->tm_sec; rtctimeforminusck2[1] = timey->tm_min; rtctimeforminusck2[2] = timey->tm_hour; rtctimeforminusck2[3] = timey->tm_mday; rtctimeforminusck2[4] = timey->tm_mon + 1; rtcpos = 0; rtctime[4] = rtctimeforminusck2[4] << 4; rtctime[3] = ((rtctimeforminusck2[3] / 10) << 4) + rtctimeforminusck2[3] % 10; rtctime[2] = ((rtctimeforminusck2[2] / 10) << 4) + rtctimeforminusck2[2] % 10; rtctime[1] = ((rtctimeforminusck2[1] / 10) << 4) + rtctimeforminusck2[1] % 10; rtctime[0] = ((rtctimeforminusck2[0] / 10) << 4) + rtctimeforminusck2[0] % 10; rtcdata = rtctime[0] & 0x01; break; case 2: for (int cnt = 0; cnt < 5; cnt++) { if (cnt != 4) { rtctime[cnt] = rtctimetmp[cnt]; } else { rtctime[cnt] = (rtctimetmp[cnt] - 1); } }for (int cnt = 0; cnt < 5; cnt++) { if (cnt != 4) { rtctimeforminus[cnt] = (((rtctime[cnt] >> 4) * 10) + (rtctime[cnt] & 15)); } else { rtctimeforminus[cnt] = (rtctime[cnt] >> 4); } } timezforch1.tm_sec = rtctimeforminus[0] % 60; timezforch1.tm_min = rtctimeforminus[1] % 60; timezforch1.tm_hour = rtctimeforminus[2] % 24; timezforch1.tm_mday = rtctimeforminus[3] % 32; timezforch1.tm_mon = ((rtctimeforminus[4] - 1) % 12) + 1; timezforch1.tm_year = 71; tofs = mktime(&timezforch1) - time(0); break; } }
void rtcshift() { if (rtcpos < 40) { if ((pch >> 3 & 1)) { rtctimetmp[rtcpos >> 3] |= (pch >> 3 & 1) << (rtcpos & 7); } else { rtctimetmp[rtcpos >> 3] &= ~(1 << (rtcpos & 7)); }rtcpos += 1; rtcdata = (rtctime[rtcpos >> 3] >> (rtcpos & 7) & 1) ? true : false; }  }
void prtstrobe() {if (prtenable && prtenable0 != 0 && pch != 13){}prtenable0 = prtenable;}

bool cmtreseted = false;

UINT16 howmanypluginsloaded;

bool greenmonitor = false;

bool isenabledpcg = false;

struct typeofpluginctx {
    UINT32 version;
    BOOL ispluginloaded;
    BOOL isexecutedontheemulator;
    UINT32 plugintype[24];
    int(*ptrofz80memaccess)(int,int,int);
    int(*uniquememaccess)(int, int, int);
} pluginctx[1024];

typedef BOOL typeofEmuInitialize(void);
BOOL(*EmuInitialize)(void);
typedef DWORD typeofEmuExecute(DWORD Addr, int NParams, ...);
DWORD(*EmuExecute)(DWORD Addr, int NParams, ...);

typedef DWORD typeofPeLdrLoadModule(LPCWSTR FileName);
DWORD(*PeLdrLoadModule)(LPCWSTR FileName);
typedef DWORD typeofPeLdrLoadModuleA(LPCSTR FileNameA);
DWORD(*PeLdrLoadModuleA)(LPCSTR FileNameA);
typedef DWORD typeofPeLdrGetModuleBase(DWORD Pe);
DWORD(*PeLdrGetModuleBase)(DWORD Pe);

typedef DWORD typeofPeLdrFindModuleByBase(DWORD Base);
DWORD(*PeLdrFindModuleByBase)(DWORD Base);
typedef FARPROC typeofPeLdrGetProcAddressA(DWORD Pe, LPCSTR Name);
FARPROC(*PeLdrGetProcAddressA)(DWORD Pe, LPCSTR Name);

FARPROC x86_GetProcAddress(DWORD Pe, LPCSTR Name) {
    return PeLdrGetProcAddressA(PeLdrFindModuleByBase(Pe), Name);
}

DWORD x86_LoadLibraryA(LPCSTR FileNameA) {
    return PeLdrLoadModuleA(FileNameA);
};
DWORD x86_LoadLibraryW(LPCWSTR FileName) {
    return PeLdrLoadModule(FileName);
};
DWORD x86_LoadLibraryAEx(LPCSTR FileNameA,HANDLE hFile,DWORD dwFlags) {
    return PeLdrLoadModuleA(FileNameA);
};
DWORD x86_LoadLibraryWEx(LPCWSTR FileName,HANDLE hFile,DWORD dwFlags) {
    return PeLdrLoadModule(FileName);
};

UINT8 pcgtmp = 0;
UINT16 pcgaddr = 0;

UINT8 pcgcharram[0x400];

int z80memaccess(int prm_0, int prm_1, int prm_2) {
    switch (prm_2){
    case 0:
        memory[prm_0 & 0xFFFF] = prm_1 & 0xFF;
        return 0;
        break;
    case 1:
        if ((prm_0 & 0xFFFF) < 0x6000 && biosromenabled == false) { return bios[prm_0 & 0xFFFF]; }
        else { return memory[prm_0 & 0xFFFF]; }
        break;
    case 2:
        switch (prm_0 & 0xFF) {
        case 0x00:
            pcgtmp = prm_1;
            break;
        case 0x01:
            pcgaddr = (pcgaddr & 0xFF00) | ((prm_1 & 0xFF) << (8 * 0));
            break;
        case 0x02:
            pcgaddr = (pcgaddr & 0x00FF) | ((prm_1 & 0x03) << (8 * 1));
            if (prm_1 & 32) { pcgcharram[pcgaddr] = fontrom[0x400 + pcgaddr]; }
            else if (prm_1 & 16) { pcgcharram[pcgaddr] = pcgtmp; pcgtmp = 0; }
            break;
        case 0x10:
        case 0x11:
        case 0x12:
        case 0x13:
        case 0x14:
        case 0x15:
        case 0x16:
        case 0x17:
        case 0x18:
        case 0x19:
        case 0x1A:
        case 0x1B:
        case 0x1C:
        case 0x1D:
        case 0x1E:
        case 0x1F:
            pch = prm_1;
            break;
        case 0x20:
        case 0x22:
        case 0x24:
        case 0x26:
        case 0x28:
        case 0x2A:
        case 0x2C:
        case 0x2E:
            cmtfile = fopen(FileName, "ab"); if (cmtfile != 0) { fputc(prm_1, cmtfile); fclose(cmtfile); }
            //if (uPD8251config[3] & 1) { cmtfile = fopen(FileName, "ab"); if (cmtfile != 0) { fputc(prm_1, cmtfile); fclose(cmtfile); } }
            break;
        case 0x21:
        case 0x23:
        case 0x25:
        case 0x27:
        case 0x29:
        case 0x2B:
        case 0x2D:
        case 0x2F:
            //if (prm_1 == 0x40) { cmtreseted = true; }
            return 0;
            if (upd8251configate == 1) { uPD8251config[3] = (prm_1 & 0xFF);/*=(upd8251config&0x00FFFFFF)|((_z80_data&0xFF)<<24)*/ if (uPD8251config[3] & 64) { uPD8251config[0] = 0; uPD8251config[1] = 0; uPD8251config[2] = 0; uPD8251config[3] = 0; } if (uPD8251config[3] & 16) { overrunerror = false; rxdataready = false; } }
            else { uPD8251config[0] = (prm_1 & 0xFF);/*upd8251config=(upd8251config&0xFFFFFF00)|((_z80_data&0xFF)<<0)*/ }
            upd8251configate++; if (upd8251configate >= 2) { upd8251configate = 0; }
            break;
        case 0x30:
        case 0x32:
        case 0x34:
        case 0x36:
        case 0x38:
        case 0x3A:
        case 0x3C:
        case 0x3E:
            cmtbinsnd = (prm_1 >> 4) & 0x3;
            cassettemtstate = (prm_1 >> 3) & 0x1;
            cmtdatawr = (prm_1 >> 2) & 0x1;
            crtmodectrl = (prm_1 >> 1) & 0x1;
            pc8001widthflag = (prm_1 >> 0) & 0x1;
            break;
        case 0x31:
        case 0x33:
        case 0x35:
        case 0x37:
        case 0x39:
        case 0x3B:
        case 0x3D:
        case 0x3F:
            crtc3 = prm_1;
                bgcolor = (prm_1 >> 5) & 0x7;
            colorgraphicmode = ((prm_1 >> 4) & 0x1) ? true : false;
            graphicdraw = ((prm_1 >> 3) & 0x1 )? true:false;
            grpmode = ((prm_1 >> 2) & 0x1) ? true : false;
            biosromenabled = ((prm_1 >> 1) & 0x1) ? true : false;
            romtype = ((prm_1 >> 0) & 0x1) ? true : false;
            break;
        case 0x40:
        case 0x41:
        case 0x42:
        case 0x43:
        case 0x44:
        case 0x45:
        case 0x46:
        case 0x47:
        case 0x48:
        case 0x49:
        case 0x4A:
        case 0x4B:
        case 0x4C:
        case 0x4D:
        case 0x4E:
        case 0x4F:
            uopout = (prm_1 >> 6) & 0x03;
            beepenabled = ((prm_1 >> 5) & 0x01)?true:false;
                crtcldsclkenable = (prm_1 >> 3) & 0x01;
                rtcclkenable = (prm_1 >> 2) & 0x01;
                rtcstbenable = (prm_1 >> 1) & 0x01;
                if (rtcstbenable == true) { rtcstrobe(); }
                else { if (rtcclkenable == true) { rtcshift(); } }
                prtenable = (prm_1 >> 0) & 0x01; prtstrobe();
            break;
        case 0x50:
        case 0x52:
        case 0x54:
        case 0x56:
        case 0x58:
        case 0x5A:
        case 0x5C:
        case 0x5E:
            uPD3301prm = prm_1;
                if (seq){
                    switch (seq--) {
                    case 1:
                        colorgraphicmode = ((prm_1 >> 4) & 0x1) ? true : false;
                        crtcactive = 0;
                        break;
                    case 3:
                        grpheight25 = ((prm_1 & 0x1f) < 9) ? true : false;
                        blinkingtime = ((prm_1 >> 6) & 3);
                        break;
                    case 6:
                        cursx = cursxtmp;
                        cursy = prm_1;
                        seq = 0;
                        break;
                    case 7:
                        cursxtmp = prm_1;
                        break;
                    }
                }
            break;
        case 0x51:
        case 0x53:
        case 0x55:
        case 0x57:
        case 0x59:
        case 0x5B:
        case 0x5D:
        case 0x5F:
            upd3301cmd = prm_1;
            switch (prm_1 & 0xF0){
            case 0x00:
                seq = 5;
                crtcactive = 0;
                break;
            case 0x60:
                if (((prm_1 & 0xF)) == 0) { upd3301stat = upd3301stat & (0xFF - 1); upd31speclzsig = 1; }
                break;
            case 0x80:
                if (((prm_1 & 0xF) & 0x01) == 0) {
                    cursx = -1;
                    cursy = -1;
                }
            if (((prm_1 & 0xF) & 0x01) == 1){
                seq = 7;
            }
            break;
        }
            break;
        case 0x60:
            dmaas[0] = (dmaas[0] & (((dmachiocnt >> 0) & 1) ? 0x00FF : 0xFF00)) | ((prm_1 & 0xFF) << (((dmachiocnt >> 0) & 1) * 8)); dmachiocnt ^= (1 << 0);
            break;
        case 0x61:
            dmatc[0] = (dmatc[0] & (((dmachiocnt >> 1) & 1) ? 0x00FF : 0xFF00)) | ((prm_1 & 0xFF) << (((dmachiocnt >> 1) & 1) * 8)); dmachiocnt ^= (1 << 1);
            break;
        case 0x62:
            dmaas[1] = (dmaas[1] & (((dmachiocnt >> 2) & 1) ? 0x00FF : 0xFF00)) | ((prm_1 & 0xFF) << (((dmachiocnt >> 2) & 1) * 8)); dmachiocnt ^= (1 << 2);
            break;
        case 0x63:
            dmatc[1] = (dmatc[1] & (((dmachiocnt >> 3) & 1) ? 0x00FF : 0xFF00)) | ((prm_1 & 0xFF) << (((dmachiocnt >> 3) & 1) * 8)); dmachiocnt ^= (1 << 3);
            break;
        case 0x64:
            dmaas[2] = (dmaas[2] & (((dmachiocnt >> 4) & 1) ? 0x00FF : 0xFF00)) | ((prm_1 & 0xFF) << (((dmachiocnt >> 4) & 1) * 8)); dmachiocnt ^= (1 << 4);
            break;
        case 0x65:
            dmatc[2] = (dmatc[2] & (((dmachiocnt >> 5) & 1) ? 0x00FF : 0xFF00)) | ((prm_1 & 0xFF) << (((dmachiocnt >> 5) & 1) * 8)); dmachiocnt ^= (1 << 5);
            break;
        case 0x66:
            dmaas[3] = (dmaas[3] & (((dmachiocnt >> 6) & 1) ? 0x00FF : 0xFF00)) | ((prm_1 & 0xFF) << (((dmachiocnt >> 6) & 1) * 8)); dmachiocnt ^= (1 << 6);
            break;
        case 0x67:
            dmatc[3] = (dmatc[3] & (((dmachiocnt >> 7) & 1) ? 0x00FF : 0xFF00)) | ((prm_1 & 0xFF) << (((dmachiocnt >> 7) & 1) * 8)); dmachiocnt ^= (1 << 7);
            break;
        case 0x68:
            dmamodestat = prm_1;
            dmaseq = 2;
            break;
		case 0xE6:
			ioporte6h = prm_1;
			break;
        }
        break;
    case 3:
        switch (prm_0 & 0xFF) {
        case 0x00:
        case 0x01:
        case 0x02:
        case 0x03:
        case 0x04:
        case 0x05:
        case 0x06:
        case 0x07:
        case 0x08:
        case 0x09:
        case 0x0A:
        case 0x0B:
        case 0x0C:
        case 0x0D:
        case 0x0E:
        case 0x0F:
            return ~pc8001keybool[prm_0 & 0xF];
            break;
        case 0x20:
        case 0x22:
        case 0x24:
        case 0x26:
        case 0x28:
        case 0x2A:
        case 0x2C:
        case 0x2E:
            //MessageBoxA(0, "A", "A", 0);
            if (cmtreseted == true) { cmtreseted = false; cmtseek = 0; return 0xff; }
            else { cmtfile = fopen(FileName, "rb"); if (cmtfile != 0) { struct _stat buf; int result = _stat(FileName, &buf); if (buf.st_size <= cmtseek) { cmtseek = 0; fclose(cmtfile); return 0xFF; } fseek(cmtfile, cmtseek++, SEEK_SET); ret = fgetc(cmtfile); fclose(cmtfile); return ret; } else { return 0xff; } }
            return 0xff;
            //if (uPD8251config[3] & 4) { if (cmtreseted == true) { cmtreseted = false; cmtseek = 0; return 0xff; } else { cmtfile = fopen(FileName, "rb"); if (cmtfile != 0) { fseek(cmtfile, cmtseek++, SEEK_SET); ret = fgetc(cmtfile); fclose(cmtfile); return ret; } } }
            return uPD8251config[2];
            break;
        case 0x21:
        case 0x23:
        case 0x25:
        case 0x27:
        case 0x29:
        case 0x2B:
        case 0x2D:
        case 0x2F:
            //return 0x07;
            return uPD8251config[1] | (( rxdataready ? 1 : 0 ) << 1) | ( ( ( uPD8251config[3] & 1 ) ? 1 : 0) << 0 );
            break;
        case 0x30:
        case 0x32:
        case 0x34:
        case 0x36:
        case 0x38:
        case 0x3A:
        case 0x3C:
        case 0x3E:
            return crtc2;
            break;
        case 0x31:
        case 0x33:
        case 0x35:
        case 0x37:
        case 0x39:
        case 0x3B:
        case 0x3D:
        case 0x3F:
            return ((bgcolor & 0x7) << 5) | ((colorgraphicmode ? 1 : 0) << 4) | ((graphicdraw ? 1 : 0) << 3) | ((grpmode ? 1 : 0) << 2) | ((biosromenabled ? 1 : 0) << 1) | ((romtype ? 1 : 0) << 0);
            break;
        case 0x40:
        case 0x41:
        case 0x42:
        case 0x43:
        case 0x44:
        case 0x45:
        case 0x46:
        case 0x47:
        case 0x48:
        case 0x49:
        case 0x4A:
        case 0x4B:
        case 0x4C:
        case 0x4D:
        case 0x4E:
        case 0x4F:
            return ((uipin & 3) << 6) | ((vbi ? 1 : 0) << 5) | ((rtcdata & 1) << 4) | ((fddconnected ? 1 : 0) << 3) | ((cmtdatard ? 1 : 0) << 2) | ((prtready ? 1 : 0) << 0);
            break;
        case 0x50:
        case 0x52:
        case 0x54:
        case 0x56:
        case 0x58:
        case 0x5A:
        case 0x5C:
        case 0x5E:
            if (upd31speclzsig == 0) { return uPD3301prm; }
            else {
                switch (upd31speclzsig & 0xFF) {
                case 1:
                    ret = (litepeninp >> (((upd31speclzsig >> 8) & 0xFF) * 8));
                        break;
                }
                upd31speclzsig = (upd31speclzsig & 0xFFFF00FF) | ((((upd31speclzsig >> 8) & 0xFF) + 1) << 8);
                if (((upd31speclzsig >> 8)&0xFF) >= 2) { upd31speclzsig = 0; litepeninp = 0; }
                return ret;
                }

            break;
        case 0x51:
        case 0x53:
        case 0x55:
        case 0x57:
        case 0x59:
        case 0x5B:
        case 0x5D:
        case 0x5F:
            if (upd3301stat & 8) { return upd3301stat & (0xFF - 0x10); }
            else { return upd3301stat; }

            break;
        case 0x60:
            ret = dmaas[0] >> (((dmachiocnt >> 0) & 1) * 8); dmachiocnt ^= (1 << 0); return ret;
            break;
        case 0x61:
            ret = dmatc[0] >> (((dmachiocnt >> 1) & 1) * 8); dmachiocnt ^= (1 << 1); return ret;
            break;
        case 0x62:
            ret = dmaas[1] >> (((dmachiocnt >> 2) & 1) * 8); dmachiocnt ^= (1 << 2); return ret;
            break;
        case 0x63:
            ret = dmatc[1] >> (((dmachiocnt >> 3) & 1) * 8); dmachiocnt ^= (1 << 3); return ret;
            break;
        case 0x64:
            ret = dmaas[2] >> (((dmachiocnt >> 4) & 1) * 8); dmachiocnt ^= (1 << 4); return ret;
            break;
        case 0x65:
            ret = dmatc[2] >> (((dmachiocnt >> 5) & 1) * 8); dmachiocnt ^= (1 << 5); return ret;
            break;
        case 0x66:
            ret = dmaas[3] >> (((dmachiocnt >> 6) & 1) * 8); dmachiocnt ^= (1 << 6); return ret;
            break;
        case 0x67:
            ret = dmatc[3] >> (((dmachiocnt >> 7) & 1) * 8); dmachiocnt ^= (1 << 7); return ret;
            break;
        case 0x68:
            return dmamodestat | ((1 << 4) * ((clockcount % 19) > 9));
            break;
		case 0xE6:
			return ioporte6h;
			break;
        }
        //return 0xff;
        break;
    }
    BOOL isretvalfrompluginactive = false;
    UINT8 retvalfromplugin = 0;
    for (int cnt = 0; cnt < howmanypluginsloaded; cnt++) { for (int cnt4pluginctx = 0; cnt4pluginctx < 24; cnt4pluginctx++) { if ((pluginctx[cnt].ispluginloaded == true) && ((pluginctx[cnt].plugintype[cnt4pluginctx]) & 0x10000)) { if (pluginctx[cnt].isexecutedontheemulator == false) { retvalfromplugin |= pluginctx[cnt].uniquememaccess(prm_0, prm_1, prm_2); } else { retvalfromplugin |= EmuExecute((DWORD)&pluginctx[cnt].uniquememaccess, 3, prm_0, prm_1, prm_2); } isretvalfrompluginactive = true; } } }
    if (isretvalfrompluginactive == true) { return retvalfromplugin; }
    else { return 0xff; }
}

COLORREF GetBrushColor(HBRUSH brush)
{
    LOGBRUSH lbr;
    if (GetObject(brush, sizeof(lbr), &lbr) != sizeof(lbr)) {
        // Not even a brush!
        return CLR_NONE;
    }
    if (lbr.lbStyle != BS_SOLID) {
        // Not a solid color brush.
        return CLR_NONE;
    }
    return lbr.lbColor;
}

HWND hwnd4mw;

uint8 z80irqid = 0;
uint8 z80irqfn = 0;

extern void DrawGrp();

void RunZ80Infinity(LPVOID* arg4rz80) { SYSTEMTIME st_st; SYSTEMTIME st_goal; int ststgoal16; while (true) { clockcount = 0; int clockcountinternal = 0; int z80timerbefore = time(NULL); while (clockcount < (graphicdraw ? 1830000 : 4000000)) { clockcountinternal = 0; GetSystemTime(&st_st); while (clockcountinternal < ((graphicdraw ? 1830000 : 4000000) / 60)) { if (z80irqid != 0) { if (z80irqid == 1) { Z80DoIRQ(z80irqfn); z80irqfn = 0; } else { Z80DoNMI(); } z80irqid = 0; } clockcountinternal += Z80Run(); vbi = vbi ? false : true; } clockcount += clockcountinternal; /*drawgrpbool = true;*/ GetSystemTime(&st_goal); ststgoal16 = (st_goal.wMilliseconds) - (st_st.wMilliseconds); if (ststgoal16 < 0) { ststgoal16 += 1000; } if (ststgoal16 < 16) { Sleep(16 - ststgoal16); } }/*while (z80timerbefore == time(NULL)) {}*/ } }//UINT32 z80timemintab[2] = { 0, 0 }; SYSTEMTIME z80timeminta; while (true) { clockcount = 0; int clockcountinternal = 0; int z80timerbefore = time(NULL); while (clockcount < (graphicdraw ? 1830000 : 4000000)) { clockcountinternal = 0; GetSystemTime(&z80timeminta); z80timemintab[0] = (z80timeminta.wMilliseconds) + (time(NULL) * 1000); while (clockcountinternal < (graphicdraw ? 183000 : 400000)) { if (z80irqid != 0) { if (z80irqid == 1) { Z80DoIRQ(z80irqfn); z80irqfn = 0; } else { Z80DoNMI(); } z80irqid = 0; } clockcountinternal += Z80Run(); vbi = vbi ? false : true; } GetSystemTime(&z80timeminta); z80timemintab[1] = (z80timeminta.wMilliseconds) + (time(NULL) * 1000); clockcount += clockcountinternal; int timetowaitive = (z80timemintab[1] - z80timemintab[0]); /*if (timetowaitive < 0) { timetowaitive += 1000; }*/ if ((timetowaitive > 0) && (timetowaitive <= 100)) { Sleep(100 - timetowaitive); } else { Sleep(100); } } int z80timerint = time(NULL) - z80timerbefore; /*if (z80timerint < 1000) { Sleep(1000 - z80timerint); }*/ } }

void Z80INT(uint8 prm_0) { z80irqid = 1; z80irqfn = prm_0; }
void Z80NMI() { z80irqid = 2; }

void BeepService(LPVOID* arg4bs) { while (true) { if (beepenabled) { /*Beep(2400, 100);*/ beep2400play(); } else { beep2400stop(); } } }

void RTIService(LPVOID* arg4rtisv) { while (true) { if (ioporte6h & 1) { Z80INT(4); } Sleep(2); } }

int xsiz10times = 0;
int ysiz10times = 0;

uint8 color4draw = 0;

UINT8 prevchar[256];

void SetPalette4emu(int prm_0) { color4draw = prm_0+(greenmonitor?128:0); }

void SetPset(int prm_0, int prm_1) {
    xsiz10times = pc8001widthflag ? 100 : 200; ysiz10times = grpheight25 ? 240 : 300;
    //xsiz10times = pc8001widthflag ? 10 : 20; ysiz10times = grpheight25 ? 24 : 30;
    //xsiz10times = pc8001widthflag ? 100 : 200; ysiz10times = grpheight25 ? 213 : 267;
    //xsiz10times = 10; ysiz10times = 10;
    rs.left = (((prm_0 + 0) * xsiz10times) / 100);
    rs.top = (((prm_1 + 0) * ysiz10times) / 100);
    rs.right = (((prm_0 + 1) * xsiz10times) / 100);
    rs.bottom = (((prm_1 + 1) * ysiz10times) / 100);
    if (chkedbb8 >= 1) {
        DWORD basecolor1 = GetPixel(hCDC, rs.left, rs.top);
        DWORD basecolor2 = GetBrushColor(hBackGround[color4draw]);
        if (basecolor1 == GetBrushColor(hBackGround[32 + bgcolor])) { basecolor1 = basecolor2; }
        HBRUSH hbkgtmp = CreateSolidBrush( ((( ((basecolor1 >> (8 * 0)) & 0xFF) + (( ((basecolor1 >> (8 * 0)) & 0xFF) - ((basecolor2 >> (8 * 0)) & 0xFF)) / 2)) & 0xFF) << (8 * 0)) | (((((basecolor1 >> (8 * 1)) & 0xFF) + ((((basecolor1 >> (8 * 1)) & 0xFF) - ((basecolor2 >> (8 * 1)) & 0xFF)) / 2)) & 0xFF) << (8 * 1)) | (((((basecolor1 >> (8 * 2)) & 0xFF) + ((((basecolor1 >> (8 * 2)) & 0xFF) - ((basecolor2 >> (8 * 2)) & 0xFF)) / 2)) & 0xFF) << (8 * 2)) );
        FillRect(hCDC, &rs, hbkgtmp);
        DeleteObject(hbkgtmp);
    }
    else {
        FillRect(hCDC, &rs, hBackGround[color4draw]);
    }
}
void SetBox(int prm_0, int prm_1, int prm_2, int prm_3) {
    xsiz10times = pc8001widthflag ? 100 : 200; ysiz10times = grpheight25 ? 240 : 300;
    //xsiz10times = pc8001widthflag ? 10 : 20; ysiz10times = grpheight25 ? 24 : 30;
    //xsiz10times = pc8001widthflag ? 100 : 200; ysiz10times = grpheight25 ? 213 : 267;
    //xsiz10times = 10; ysiz10times = 10;
    rs.left = (((prm_0 + 0) * xsiz10times) / 100);
    rs.top = (((prm_1 + 0) * ysiz10times) / 100);
    rs.right = (((prm_2 + 0) * xsiz10times) / 100);
    rs.bottom = (((prm_3 + 0) * ysiz10times) / 100);
    if (chkedbb8 >= 1) {
        DWORD basecolor1 = GetPixel(hCDC, rs.left, rs.top);
        DWORD basecolor2 = GetBrushColor(hBackGround[color4draw]);
        if (basecolor1 == GetBrushColor(hBackGround[32 + bgcolor])) { basecolor1 = basecolor2; }
        HBRUSH hbkgtmp = CreateSolidBrush((((((basecolor1 >> (8 * 0)) & 0xFF) + ((((basecolor1 >> (8 * 0)) & 0xFF) - ((basecolor2 >> (8 * 0)) & 0xFF)) / 2)) & 0xFF) << (8 * 0)) | (((((basecolor1 >> (8 * 1)) & 0xFF) + ((((basecolor1 >> (8 * 1)) & 0xFF) - ((basecolor2 >> (8 * 1)) & 0xFF)) / 2)) & 0xFF) << (8 * 1)) | (((((basecolor1 >> (8 * 2)) & 0xFF) + ((((basecolor1 >> (8 * 2)) & 0xFF) - ((basecolor2 >> (8 * 2)) & 0xFF)) / 2)) & 0xFF) << (8 * 2)));
        FillRect(hCDC, &rs, hbkgtmp);
        DeleteObject(hbkgtmp);
    }
    else {
        FillRect(hCDC, &rs, hBackGround[color4draw]);
    }
}

void SetBGCL(){
    rs.left = 0;
    rs.top = 0;
    rs.right = 640;
    rs.bottom = 480;
    FillRect(hCDC, &rs, hBackGround[color4draw]);
}


void DrawFont(int prm_0, int prm_1, int prm_2) {
    for (int fonty = 0; fonty < 8; fonty++) {
        for (int fontx = 0; fontx < 8; fontx++) {
            if (((isenabledpcg ? ((prm_2 < 128) ? fontrom[prm_2 * 8 + fonty] : pcgcharram[(prm_2 * 8 + fonty)-0x400]) : fontrom[prm_2 * 8 + fonty]) << fontx) & 128) { SetPset(prm_0 + fontx, prm_1 + fonty); }
        }
    }

}
void DrawFontUS(int prm_0, int prm_1, int prm_2,int prm_3) {
    int fonty = 0;
    for (int fontx = 0; fontx < 8; fontx++) {
        if ((((isenabledpcg ? ((prm_3 < 128) ? fontrom[prm_3 * 8 + 7] : pcgcharram[(prm_3 * 8 + 7) - 0x400]) : fontrom[prm_3 * 8 + 7]) & (isenabledpcg ? ((prm_2 < 128) ? fontrom[prm_2 * 8 + fonty] : pcgcharram[(prm_2 * 8 + fonty) - 0x400]) : fontrom[prm_2 * 8 + fonty])) << fontx) & 128) { SetPset(prm_0 + fontx, prm_1 + fonty - 1); }
    }

}

int attributeold = -1;
int attributetmp = -1;
int attributeold2 = -1;
int attributetmp2 = -1;
int attributeold3 = -1;
int attributetmp3 = -1;
bool attributegcold = false;
uint8 charattribute = 0;
uint8 fontcolors = 0;
uint8 grpcolors = 0;
uint8 charattributeold = 0;
bool blinkai = false;
bool blinkai2 = false;
bool semigraphicenabled = false;
int blinkwaitisti = 0;

int lp_ggxy[2];
bool mousemvenabled = false;

void DrawGrp() {
    if ((graphicdraw == true)/* || (true)*/) {
        if (crtmodectrl == false) { SetPalette4emu(32 + bgcolor); }
        else { SetPalette4emu(32 + 8); }
        SetBGCL();
        for (chkedbb8 = 0; chkedbb8 < (((dmatc[2]&0x3FFF) >= 0xbb8) ? (((dmatc[2] & 0x3FFF) / 0xbb8) + 1) : 1); chkedbb8++) {
            bool breakdowndgp = false;
            for (int drawbacky = 0; drawbacky < (grpheight25 ? 25 : 20); drawbacky++) {
                for (int drawbackx = 0; drawbackx < (pc8001widthflag ? 80 : 40); drawbackx++) {
                    if (((chkedbb8 * 0xbb8) + ((drawbackx * (pc8001widthflag ? 1 : 2)) + (drawbacky * 120))) > (dmatc[2] & 0x3FFF)) { breakdowndgp = true; break; }
                    uint8 char4show = z80memaccess(dmaas[2] + (chkedbb8 * 0xbb8) + ((drawbackx * (pc8001widthflag ? 1 : 2)) + (drawbacky * 120)), 0, 1);
                    attributetmp = -1; attributeold = -1; fontcolors = 0; grpcolors = 0; attributegcold = false;
                    attributeold2 = -1; attributetmp2 = -1; attributeold3 = -1; attributetmp3 = -1; semigraphicenabled = false;
                    for (int cnt = 0; cnt < 20; cnt++) {
                        uint8 charattributetmp = z80memaccess(dmaas[2] + (chkedbb8*0xbb8) + (((cnt * 2) + 81) + (drawbacky * 120)), 0, 1); if ((z80memaccess(dmaas[2] + (chkedbb8 * 0xbb8) + (((cnt * 2) + 80) + (drawbacky * 120)), 0, 1) & 0x7F) != (64 | 32)) { if (charattributetmp & 8) { attributetmp = z80memaccess(dmaas[2] + (chkedbb8 * 0xbb8) + (((cnt * 2) + 80) + (drawbacky * 120)), 0, 1) / (pc8001widthflag ? 1 : 2); if (attributetmp <= drawbackx && attributetmp > attributeold) { attributeold = attributetmp; fontcolors = (charattributetmp >> 5) & 7; grpcolors = (charattributetmp >> 5) & 7; if (charattributetmp & 16) { semigraphicenabled = true; } else { semigraphicenabled = false; } } } else { attributetmp3 = z80memaccess(dmaas[2] + (chkedbb8 * 0xbb8) + (((cnt * 2) + 80) + (drawbacky * 120)), 0, 1) / (pc8001widthflag ? 1 : 2); if ((attributetmp3 <= drawbackx && attributetmp3 > attributeold3) || (((((charattributetmp & 128) ? true : false) != attributegcold) && (charattributetmp & 128)))) { charattribute = charattributetmp; attributeold3 = attributetmp3; attributegcold = (charattributetmp & 128) ? true : false; } } }
                    }
                    if (semigraphicenabled == true) { charattribute |= 128; }
                    //grpcolors = 9;
                    if (charattribute & 4) { if (crtmodectrl == false) { if (charattribute & 128) { SetPalette4emu(grpcolors); } else { SetPalette4emu(fontcolors); } } else { SetPalette4emu(9); } }
                    else { if (crtmodectrl == false) { SetPalette4emu(32 + bgcolor); } else { SetPalette4emu(32 + 8); } }
                    if ((cursx != -1 && cursy != -1) && (cursx == (drawbackx * (pc8001widthflag ? 1 : 2)) && cursy == drawbacky)) {
                        if (blinkai2 == false) {
                            if (charattribute & 4) { if (crtmodectrl == false) { SetPalette4emu(32 + bgcolor); } else { SetPalette4emu(32 + 8); } }
                            else { if (crtmodectrl == false) { if (charattribute & 128) { SetPalette4emu(grpcolors); } else { SetPalette4emu(fontcolors); } } else { SetPalette4emu(9); } }
                            SetBox((((cursx / (pc8001widthflag ? 1 : 2)) + 0) * 8), ((cursy + 0) * 8), (((cursx / (pc8001widthflag ? 1 : 2)) + 1) * 8) - 0, ((cursy + 1) * 8) - 0);
                        }
                    }
                    if (((blinkai == false) || ((charattribute & 2) == 0)) && ((charattribute & 1) == 0)) {
                        SetBox(((drawbackx + 0) * 8), ((drawbacky + 0) * 8), ((drawbackx + 1) * 8) - 0, ((drawbacky + 1) * 8) - 0);
                        if ((cursx == (drawbackx * (pc8001widthflag ? 1 : 2)) && cursy == drawbacky) && (blinkai2 == false)) {
                            if (charattribute & 4) { if (crtmodectrl == false) { if (charattribute & 128) { SetPalette4emu(grpcolors); } else { SetPalette4emu(fontcolors); } } else { SetPalette4emu(9); } }
                            else { if (crtmodectrl == false) { SetPalette4emu(32 + bgcolor); } else { SetPalette4emu(32 + 8); } }
                        }
                        else {
                            if (charattribute & 4) { if (crtmodectrl == false) { SetPalette4emu(32 + bgcolor); } else { SetPalette4emu(32 + 8); } }
                            else { if (crtmodectrl == false) { if (charattribute & 128) { SetPalette4emu(grpcolors); } else { SetPalette4emu(fontcolors); } } else { SetPalette4emu(9); } }
                        }
                        if ((charattribute & 128) || (attributegcold == true)) { for (int cnt = 0; cnt < 8; cnt++) { if ((char4show >> cnt) & 1) { SetBox(((drawbackx + 0) * 8) + (4 * ((cnt / 4) + 0)) - 0, ((drawbacky + 0) * 8) + ((int)(2 * ((cnt % 4) + 0))) - 0, ((drawbackx + 0) * 8) + (4 * ((cnt / 4) + 1)) - 0, ((drawbacky + 0) * 8) + ((int)(2 * ((cnt % 4) + 1))) - 0); } } }
                        else { /*DrawFontUS(((drawbackx + 0) * 8), ((drawbacky + 0) * 9), char4show, prevchar[drawbackx]);*/ DrawFont(((drawbackx + 0) * 8), ((drawbacky + 0) * 8), char4show); prevchar[drawbackx] = char4show; }
                        //SetPalette4emu(9); SetBox(((drawbackx + 0) * 8), ((drawbacky + 0) * 8), ((drawbackx + 1) * 8) - 0, ((drawbacky + 1) * 8) - 0);
                        if (charattribute & 64) { SetBox(((drawbackx + 0) * 8) + 3, ((drawbacky + 0) * 8), ((drawbackx + 0) * 8) + 4, ((drawbacky + 1) * 8) - 0); }
                        if (charattribute & 32) { SetBox(((drawbackx + 0) * 8), ((drawbacky + 1) * 8) - 2, ((drawbackx + 1) * 8), ((drawbacky + 1) * 8) - 1); }
                        if (charattribute & 16) { SetBox(((drawbackx + 0) * 8), ((drawbacky + 0) * 8), ((drawbackx + 1) * 8), ((drawbacky + 0) * 8) + 0); }
                    }
                }
                if (breakdowndgp == true) { break; }
            }
            if (breakdowndgp == true) { break; }
        }
    }
    else { SetPalette4emu(8); SetBGCL(); }
    if (blinkingtime == blinkwaitisti) { blinkai2 = blinkai2 ? false : true; }
    if ((blinkingtime * 2) <= blinkwaitisti) { blinkai = blinkai ? false : true; blinkwaitisti = 0; }
    blinkwaitisti++;
#if 0
    SetStretchBltMode(hCDC, (isharftoneenabled ? STRETCH_HALFTONE : COLORONCOLOR));
    StretchBlt(hCDC, 0, 0, 640, 480, hCDC, 0, 0, (pc8001widthflag ? 640 : 320), (grpheight25 ? 200 : 160), SRCCOPY);
    if (isharftoneenabled == true) { SetBrushOrgEx(hCDC, 0, 0, NULL); }
#if 1
    if (isharftoneenabled == true) {
        DWORD gp4blur = 0;
        DWORD gp4blurtmp = 0;
        UINT8 gp4blurx[3][3] = { {16,8,16},{8,4,8},{16,8,16} };
        for (int cnt = 0; cnt < 480; cnt++) {
            for (int cnt2 = 0; cnt2 < 640; cnt2++) {
                if (cnt == 0 || cnt == 479 || cnt2 == 0 || cnt2 == 639) { gp4blur = ((UINT32)((UINT8)pBit[(((cnt * 640) + (639 - cnt2)) * 3) + 0]) << (8 * 0)) | ((UINT32)((UINT8)pBit[(((cnt * 640) + (639 - cnt2)) * 3) + 1]) << (8 * 1)) | ((UINT32)((UINT8)pBit[(((cnt * 640) + (639 - cnt2)) * 3) + 2]) << (8 * 2));/*GetPixel(hCDC, cnt2, cnt);*/ }
                else {
                    UINT32 gp4brur2[3] = { 0,0,0 };
                    for (int gp4bdy = -1; gp4bdy <= 1; gp4bdy++) {
                        for (int gp4bdx = -1; gp4bdx <= 1; gp4bdx++) {
                            //gp4blurtmp = GetPixel(hCDC, cnt2 + gp4bdx, cnt + gp4bdy);
                            //if (gp4bdy != gp4bdx || (gp4bdx==0 && gp4bdy==0)) {
                                gp4blurtmp = ((UINT32)((UINT8)pBit[((((cnt + gp4bdy) * 640) + (639 - (cnt2 + gp4bdx))) * 3) + 0]) << (8 * 0)) | ((UINT32)((UINT8)pBit[((((cnt + gp4bdy) * 640) + (639 - (cnt2 + gp4bdx))) * 3) + 1]) << (8 * 1)) | ((UINT32)((UINT8)pBit[((((cnt + gp4bdy) * 640) + (639 - (cnt2 + gp4bdx))) * 3) + 2]) << (8 * 2));
                                gp4brur2[0] += ((gp4blurtmp >> (8 * 0)) & 0xFF)/gp4blurx[gp4bdy+1][gp4bdx+1];
                                gp4brur2[1] += ((gp4blurtmp >> (8 * 1)) & 0xFF)/gp4blurx[gp4bdy+1][gp4bdx+1];
                                gp4brur2[2] += ((gp4blurtmp >> (8 * 2)) & 0xFF)/gp4blurx[gp4bdy+1][gp4bdx+1];
                            //}
                        }
                    }
                    /*gp4brur2[0] /= 5;
                    gp4brur2[1] /= 5;
                    gp4brur2[2] /= 5;*/
                    gp4blur = (((gp4brur2[0] & 0xFF) << (8 * 0)) | ((gp4brur2[1] & 0xFF) << (8 * 1)) | ((gp4brur2[2] & 0xFF) << (8 * 2)));
                }
                //SetPixel(hCDC, cnt2, cnt, gp4blur);
                pBit[(((cnt * 640) + (639 - cnt2)) * 3) + 0] = ((gp4blur >> (8 * 0)) & 0xFF);
                pBit[(((cnt * 640) + (639 - cnt2)) * 3) + 1] = ((gp4blur >> (8 * 1)) & 0xFF);
                pBit[(((cnt * 640) + (639 - cnt2)) * 3) + 2] = ((gp4blur >> (8 * 2)) & 0xFF);
            }
        }
    }
#endif
#endif
    RECT rw4rend;
    if (bool4showwin) {
        GetClientRect(hwnd4mw, &rw4rend);
        if ((rw4rend.right != 0) && (rw4rend.bottom != 0)) { SetStretchBltMode(hdc, (isharftoneenabled ? STRETCH_HALFTONE : COLORONCOLOR)); StretchBlt(hdc, 0, 0, rw4rend.right, rw4rend.bottom, hCDC, 0, 0, 640, 480, SRCCOPY); if (isharftoneenabled == true){ SetBrushOrgEx(hdc, 0, 0, NULL); } }
    }
    else {
        GetClientRect(HWNDfullscr, &rw4rend);
        if ((rw4rend.right != 0) && (rw4rend.bottom != 0)) { SetStretchBltMode(hdcfullscr, (isharftoneenabled ? STRETCH_HALFTONE : COLORONCOLOR)); StretchBlt(hdcfullscr, 0, 0, rw4rend.right, rw4rend.bottom, hCDC, 0, 0, 640, 480, SRCCOPY); if (isharftoneenabled == true){ SetBrushOrgEx(hdcfullscr, 0, 0, NULL); } }
    }
}

void Drawbackground(LPVOID* arg4dbg) {
    SYSTEMTIME st_st; SYSTEMTIME st_goal; int ststgoal16;
    while (true) {
        /*if (drawgrpbool == true) {
            DrawGrp();
            drawgrpbool = false;
        }*/
        GetSystemTime(&st_st);
        DrawGrp();
        GetSystemTime(&st_goal); ststgoal16 = (st_goal.wMilliseconds) - (st_st.wMilliseconds); if (ststgoal16 < 0) { ststgoal16 += 1000; } if (ststgoal16 < 17) { Sleep(17 - ststgoal16); }
        //Sleep(16);
    }
}

extern "C" __declspec(dllexport) void ResetEmu() {
    biosromenabled = false;

    clockcount = 0;
    videoenabled = false;
    beepenabled = true;
    uPD8251config[0]=0;
    uPD8251config[1]=0;
    uPD8251config[2]=0;
    uPD8251config[3]=0;
    upd8251configate = 0;
    overrunerror = false;
    rxdataready = false;
    crtc2 = 0;

    bgcolor = 0;
    colorgraphicmode = false;
    graphicdraw = true;
    grpmode = false;
    romtype = false;

    uipin = 0;
    vbi = false;
    rtcdata = false;
    fddconnected = false;
    cmtdatard = false;
    prtready = false;

    othercrtcio = false;
    upd31speclzsig;
    litepeninp;

    upd3301stat = 0;
    uPD3301prm = 0;
    upd3301cmd = 0;

    dmaas[0]=0;
    dmaas[1]=0;
    dmaas[2]=0;
    dmaas[3]=0;
    dmatc[0]=0;
    dmatc[1]=0;
    dmatc[2]=0;
    dmatc[3]=0;
    dmachiocnt = 0;
    dmamodestat = 0;
    dmaseq = 0;
    crtcactive = 0;
    cursx = -1;
    cursy = -1;

    grpheight25 = false;
    blinkingtime = 0;
    cursxtmp = 0;

    uopout = 0;

    ret = 0;

    seq = 0;

    crtc3 = 0;

    pc8001kb1p;

    crtcldsclkenable = false;
    rtcclkenable = false;
    rtcstbenable = false;
    prtenable = false;
    prtenable0 = false;

    cassettemtstate = false;
    cmtbinsnd = 0;
    cmtdatawr = false;
    crtmodectrl = false;
    pc8001widthflag = false;

    pch = 0;

    rtcpos = 0;

    ioporte6h = 0;

    mousemvenabled = false;

    Z80Init();
}

extern "C" __declspec(dllexport) bool RunEmu(HWND hWnd,HDC hdc4tmpxxxxx) {
    if (!hWnd)
    {
        return FALSE;
    }
    beepinit();

    Z80Init();
    setz80memaccess(z80memaccess);

    FILE* biosfile = fopen("n80basic.rom", "rb");
    if (biosfile != 0) {
        fread(bios, 0x6000, 1, biosfile);
        fclose(biosfile);
    }

    FILE* fontfile = fopen("font.rom", "rb");
    if (fontfile != 0) {
        fread(fontrom, 0x800, 1, fontfile);
        fclose(fontfile);
    }

    time_t timer = time(NULL);
    timexforch1 = localtime(&timer);

    //rtctimeforminus

    timexforch1tm_year4ml = (timexforch1->tm_year - 121);
    //timexforch1->tm_year -= (9+timexforch1tm_year4ml);//9;

    //timexforch1[0] = timexforch1charx->tm_sec, timexforch1charx->tm_min, timexforch1charx->tm_hour, timexforch1charx->tm_mday, timexforch1charx->tm_mon, timexforch1charx->tm_year - 9, 0, 0, 0;

    hwnd4mw = hWnd;
    HWNDfullscr = hWnd;

    hdc = hdc4tmpxxxxx;//GetDC(hWnd);
    hdcfullscr = hdc4tmpxxxxx;//GetDC(hWnd);

    BITMAPINFOHEADER* pbi;
    pbi = (LPBITMAPINFOHEADER)GlobalAlloc(GPTR, sizeof(BITMAPINFOHEADER));
    if (pbi == nullptr) { return FALSE; }
    pbi->biBitCount = 24;

    pbi->biSize = sizeof(BITMAPINFOHEADER);
    pbi->biWidth = 640;
    pbi->biHeight = 480;
    pbi->biPlanes = 1;

    hCDC = CreateCompatibleDC(hdc);
    hbDib = CreateDIBSection(hCDC, (BITMAPINFO*)pbi, DIB_RGB_COLORS, (void**)&pBit, NULL, 0);
    hCBitmap = CreateCompatibleBitmap(hdc, 640, 480);
    hCDCfullscr = CreateCompatibleDC(hdcfullscr);
    hCBitmapfullscr = CreateCompatibleBitmap(hdcfullscr, 640, 480);
    hPen = CreatePen(PS_SOLID, 1, RGB(0, 0, 0));
    for (int cnt = 0; cnt < 256; cnt++) {
        if (cnt < 8) { hBackGround[cnt] = CreateSolidBrush(RGB(((cnt >> 1) & 1) * 255, ((cnt >> 2) & 1) * 255, ((cnt >> 0) & 1) * 255)); }
        else if (cnt == 8) { hBackGround[cnt] = CreateSolidBrush(RGB(0, 0, 0)); }
        else if (cnt == 9) { hBackGround[cnt] = CreateSolidBrush(RGB(255, 255, 255)); }
        else if ((cnt < 24) && (cnt > 15)) { hBackGround[cnt] = CreateSolidBrush(RGB(((cnt >> 1) & 1) * 230, ((cnt >> 2) & 1) * 230, ((cnt >> 0) & 1) * 230)); }
        else if (cnt == 24) { hBackGround[cnt] = CreateSolidBrush(RGB(0, 0, 0)); }
        else if (cnt == 25) { hBackGround[cnt] = CreateSolidBrush(RGB(230, 230, 230)); }
        else if ((cnt > 31) && (cnt < 40)) { hBackGround[cnt] = CreateSolidBrush(RGB(((((cnt - 32) >> 1) & 1) * 253) + 1, ((((cnt - 32) >> 2) & 1) * 253) + 1, ((((cnt - 32) >> 0) & 1) * 253) + 1)); }
        else if (cnt == 41) { hBackGround[cnt] = CreateSolidBrush(RGB(1, 1, 1)); }
        else if (cnt == 42) { hBackGround[cnt] = CreateSolidBrush(RGB(253, 253, 253)); }
        else if ((cnt >= (0 + 128)) && (cnt < (8 + 128))) { hBackGround[cnt] = CreateSolidBrush(RGB(0, ((cnt - (0 + 127)) * 28) + 3, 0)); }
        else if (cnt == (8 + 128)) { hBackGround[cnt] = CreateSolidBrush(RGB(0, 31, 0)); }
        else if (cnt == (9 + 128)) { hBackGround[cnt] = CreateSolidBrush(RGB(0, 255, 0)); }
        else if ((cnt < (24 + 128)) && (cnt > (15 + 128))) { hBackGround[cnt] = CreateSolidBrush(RGB(0, ((cnt - (16 + 127)) * 25) + 5, 0)); }
        else if (cnt == (24 + 128)) { hBackGround[cnt] = CreateSolidBrush(RGB(0, 30, 0)); }
        else if (cnt == (25 + 128)) { hBackGround[cnt] = CreateSolidBrush(RGB(0, 230, 0)); }
        else if ((cnt > (31 + 128)) && (cnt < (40 + 128))) { hBackGround[cnt] = CreateSolidBrush(RGB(1, ((cnt - (32 + 127)) * 28) + 1, 1)); }
        else if (cnt == (41 + 128)) { hBackGround[cnt] = CreateSolidBrush(RGB(1, 28 + 1, 1)); }
        else if (cnt == (42 + 128)) { hBackGround[cnt] = CreateSolidBrush(RGB(0, 253, 0)); }
        else if (cnt < 128) { hBackGround[cnt] = CreateSolidBrush(RGB(0, 0, 0)); }
        else { hBackGround[cnt] = CreateSolidBrush(RGB(0, 33, 0)); }
    }

    hOldCBitmap = (HBITMAP)SelectObject(hCDC, hCBitmap);

    Z80Threadid = CreateThread(0, 0, (LPTHREAD_START_ROUTINE)RunZ80Infinity, 0, 0, 0);
    BSThreadid = CreateThread(0, 0, (LPTHREAD_START_ROUTINE)BeepService, 0, 0, 0);
    BGThreadid = CreateThread(0, 0, (LPTHREAD_START_ROUTINE)Drawbackground, 0, 0, 0);
    RTIThreadid = CreateThread(0, 0, (LPTHREAD_START_ROUTINE)RTIService, 0, 0, 0);
    return TRUE;
}

extern "C" __declspec(dllexport) void SetCMTFile(char* prm_0) { cmtreseted = true; cmtdatard = true; uPD8251config[1] = 0x7; memset(FileName,0,sizeof(FileName)); memcpy(FileName, prm_0, strlen(prm_0)); }
extern "C" __declspec(dllexport) char* GetCMTFile() { return FileName; }

extern "C" __declspec(dllexport) void SetGreenDisplay(bool prm_0) { greenmonitor = prm_0; }
extern "C" __declspec(dllexport) bool GetGreenDisplay() { return greenmonitor; }

extern "C" __declspec(dllexport) void SetPCG(bool prm_0) { if (prm_0 == true) { for (int cnt = 0; cnt < 0x400; cnt++) { pcgcharram[cnt] = rand(); } } isenabledpcg = prm_0; }
extern "C" __declspec(dllexport) bool GetPCG() { return isenabledpcg; }

extern "C" __declspec(dllexport) UINT32 CtlEmulator(UINT message, WPARAM wParam, LPARAM lParam) {
    switch (message)
    {
    case WM_MOUSEMOVE:
        if (mousemvenabled == false) { return 0; }
    case WM_LBUTTONDOWN:
        mousemvenabled = true;
        RECT rw4rend;
        if (bool4showwin) {
            GetClientRect(hwnd4mw, &rw4rend);
        }
        else {
            GetClientRect(HWNDfullscr, &rw4rend);
        }
        lp_ggxy[0] = (((((lParam >> (16 * 0)) & 0xFFFF) * (pc8001widthflag ? 80 : 40)) / rw4rend.right) + 6);
        lp_ggxy[1] = ((((lParam >> (16 * 1)) & 0xFFFF) * (grpheight25 ? 25 : 20)) / rw4rend.bottom);
        litepeninp = ((((vbi ? 1 : 0) << 7) | (lp_ggxy[0] & 127)) << 0) | ((lp_ggxy[1] & 63) << 8);
        upd3301stat |= 1;
        //rw4rend.right, rw4rend.bottom
        break;
    case WM_LBUTTONUP:
        mousemvenabled = false;
        break;
    case WM_KEYDOWN:
        if (wParam == 37 || wParam == 40) {
            pc8001kb1p = pc8001kmp[16];
            if (pc8001kb1p != 255) { pc8001keybool[(pc8001kb1p >> 4) & 0xF] |= 1 << (pc8001kb1p & 0xF); }
        }
        pc8001kb1p = pc8001kmp[wParam];
        if (pc8001kb1p != 255) { pc8001keybool[(pc8001kb1p >> 4) & 0xF] |= 1 << (pc8001kb1p & 0xF); }
        break;
    case WM_KEYUP:
        if (wParam == 37 || wParam == 40) {
            pc8001kb1p = pc8001kmp[16];
            if (pc8001kb1p != 255) { pc8001keybool[(pc8001kb1p >> 4) & 0xF] &= ~(1 << (pc8001kb1p & 0xF)); }
        }
        pc8001kb1p = pc8001kmp[wParam];
        if (pc8001kb1p != 255) { pc8001keybool[(pc8001kb1p >> 4) & 0xF] &= ~(1 << (pc8001kb1p & 0xF)); }
        break;
    }
    return 0;
}



BOOL APIENTRY DllMain( HMODULE hModule,
                       DWORD  ul_reason_for_call,
                       LPVOID lpReserved
                     )
{
    switch (ul_reason_for_call)
    {
    case DLL_PROCESS_ATTACH:
    case DLL_THREAD_ATTACH:
    case DLL_THREAD_DETACH:
    case DLL_PROCESS_DETACH:
        break;
    }
    return TRUE;
}

